from __future__ import annotations

import uuid

from pyqtgraph import mkPen

from gui_qt.lib.pg_objects import LogInfiniteLine, PlotItem


class LineObject:
    def __init__(self, **kwargs):
        self.id = str(uuid.uuid4())

        self.pos = kwargs['pos']
        self.angle = kwargs['angle']
        self.color = kwargs['color']

        self.drawing = LogInfiniteLine(pos=self.pos, angle=self.angle, pen=mkPen(color=self.color.rgb()))

    def __str__(self):
        return f'{"x" if self.angle==90 else "y"}={self.pos}'


class MultipointObject:
    def __init__(self, **kwargs):
        self.id = str(uuid.uuid4())

        self.color = kwargs['color']
        x, y = zip(*kwargs['pts'])
        self.closed = kwargs['closed']

        if self.closed:
            x += (x[0],)
            y += (y[0],)
        self._x = x
        self._y = y

        self.drawing = PlotItem(x=self._x, y=self._y, pen=mkPen(color=self.color.rgb()))

    def __str__(self):
        return f'{len(self._y)-int(self.closed)}-pts'
